# std::chrono::ambiguous_local_time

From cppreference.com
< cpp‎ | chrono

Defined in header `<chrono>` |  |
class ambiguous_local_time; |  | (since C++20)

Defines a type of object to be thrown as exception to report that an attempt was made to convert a ambiguous std::chrono::local_time to a std::chrono::sys_time without specifying a std::chrono::choose (such as `choose::earliest` or `choose::latest`).

This exception is thrown by std::chrono::time_zone::to_sys and functions that call it (such as the constructors of std::chrono::zoned_time that takes a std::chrono::local_time).

Inheritance diagram

### Member functions

(constructor) | constructs the exception object (public member function)

## std::chrono::ambiguous_local_time::ambiguous_local_time

template< class Duration > ambiguous_local_time(const std::chrono::local_time<Duration>& tp, const std::chrono::local_info& i); |  |

Constructs the exception object. The explanatory string returned by `what()` is equivalent to that produced by `os.str()` after the following code:

    std::ostringstream os;
    os << tp << " is ambiguous.  It could be\n"
       << tp << ' ' << i.first.abbrev << " == "
       << tp - i.first.offset << " UTC or\n"
       << tp << ' ' << i.second.abbrev  << " == "
       << tp - i.second.offset  << " UTC";

Because copying a standard library class derived from `std::exception` is not permitted to throw exceptions, this message is typically stored internally as a separately-allocated reference-counted string.

The behavior is undefined if i.result != std::chrono::local_info::ambiguous.

### Parameters

tp | - | the time point for which conversion was attempted
i | - | a std::chrono::local_info describing the result of the conversion attempt

### Exceptions

May throw std::bad_alloc

## Inherited from std::exception

### Member functions

(destructor) [virtual] | destroys the exception object (virtual public member function of `std::exception`)
what [virtual] | returns an explanatory string (virtual public member function of `std::exception`)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/chrono/ambiguous_local_time&oldid=104642"